--- old/usr/src/uts/common/fs/zfs/dnode.c	Mon Nov  6 02:54:42 2017
+++ new/usr/src/uts/common/fs/zfs/dnode.c	Mon Nov  6 02:54:42 2017
@@ -23,6 +23,7 @@
  * Copyright (c) 2012, 2017 by Delphix. All rights reserved.
  * Copyright (c) 2014 Spectra Logic Corporation, All rights reserved.
  * Copyright (c) 2014 Integros [integros.com]
+ * Copyright 2017 RackTop Systems.
  */
 
 #include <sys/zfs_context.h>
@@ -59,7 +60,9 @@
 int zfs_default_bs = SPA_MINBLOCKSHIFT;
 int zfs_default_ibs = DN_MAX_INDBLKSHIFT;
 
+#ifdef	_KERNEL
 static kmem_cbrc_t dnode_move(void *, void *, size_t, void *);
+#endif	/* _KERNEL */
 
 static int
 dbuf_compare(const void *x1, const void *x2)
@@ -213,7 +216,9 @@
 	dnode_cache = kmem_cache_create("dnode_t",
 	    sizeof (dnode_t),
 	    0, dnode_cons, dnode_dest, NULL, NULL, NULL, 0);
+#ifdef	_KERNEL
 	kmem_cache_set_move(dnode_cache, dnode_move);
+#endif	/* _KERNEL */
 }
 
 void
@@ -697,6 +702,7 @@
 } dnode_move_stats;
 #endif	/* DNODE_STATS */
 
+#ifdef	_KERNEL
 static void
 dnode_move_impl(dnode_t *odn, dnode_t *ndn)
 {
@@ -833,7 +839,6 @@
 	odn->dn_moved = (uint8_t)-1;
 }
 
-#ifdef	_KERNEL
 /*ARGSUSED*/
 static kmem_cbrc_t
 dnode_move(void *buf, void *newbuf, size_t size, void *arg)
--- old/usr/src/uts/common/sys/acl.h	Mon Nov  6 02:54:42 2017
+++ new/usr/src/uts/common/sys/acl.h	Mon Nov  6 02:54:42 2017
@@ -25,6 +25,7 @@
  * Use is subject to license terms.
  *
  * Copyright 2014 Nexenta Systems, Inc.  All rights reserved.
+ * Copyright 2017 RackTop Systems.
  */
 
 #ifndef _SYS_ACL_H
@@ -158,7 +159,7 @@
 
 #define	ACE_ALL_TYPES	0x001F
 
-#ifdef _KERNEL
+#if defined(_KERNEL) || defined(_FAKE_KERNEL)
 
 typedef struct ace_object {
 	uid_t		a_who;		/* uid or gid */
--- old/usr/src/uts/common/sys/bitmap.h	Mon Nov  6 02:54:42 2017
+++ new/usr/src/uts/common/sys/bitmap.h	Mon Nov  6 02:54:42 2017
@@ -26,6 +26,7 @@
 
 /*
  * Copyright (c) 2014 by Delphix. All rights reserved.
+ * Copyright 2017 RackTop Systems.
  */
 
 /*	Copyright (c) 1984, 1986, 1987, 1988, 1989 AT&T	*/
@@ -134,7 +135,7 @@
 #define	BIT_ONLYONESET(u) \
 	((((u) == 0) ? 0 : ((u) & ((u) - 1)) == 0))
 
-#if defined(_KERNEL) && !defined(_ASM)
+#if (defined(_KERNEL) || defined(_FAKE_KERNEL)) && !defined(_ASM)
 #include <sys/atomic.h>
 
 /*
@@ -188,7 +189,7 @@
  */
 #define	BITX(u, h, l)	(((u) >> (l)) & ((1LU << ((h) - (l) + 1LU)) - 1LU))
 
-#endif	/* _KERNEL && !_ASM */
+#endif	/* (_KERNEL || _FAKE_KERNEL) && !_ASM */
 
 #ifdef	__cplusplus
 }
--- old/usr/src/uts/common/sys/bitset.h	Mon Nov  6 02:54:42 2017
+++ new/usr/src/uts/common/sys/bitset.h	Mon Nov  6 02:54:42 2017
@@ -20,6 +20,7 @@
  */
 /*
  * Copyright (c) 2007, 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright 2017 RackTop Systems.
  */
 
 #ifndef	_BITSET_H
@@ -29,7 +30,7 @@
 extern "C" {
 #endif
 
-#if (defined(_KERNEL) || defined(_KMEMUSER))
+#if defined(_KERNEL) || defined(_FAKE_KERNEL) || defined(_KMEMUSER)
 #include <sys/bitmap.h>
 #include <sys/types.h>
 
@@ -87,7 +88,7 @@
 void		bitset_copy(bitset_t *, bitset_t *);
 int		bitset_match(bitset_t *, bitset_t *);
 
-#endif	/* !_KERNEL && !_KMEMUSER */
+#endif	/* _KERNEL || _FAKE_KERNEL || _KMEMUSER */
 
 #ifdef	__cplusplus
 }
--- old/usr/src/uts/common/sys/buf.h	Mon Nov  6 02:54:42 2017
+++ new/usr/src/uts/common/sys/buf.h	Mon Nov  6 02:54:42 2017
@@ -21,6 +21,8 @@
 /*
  * Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ *
+ * Copyright 2017 RackTop Systems.
  */
 
 /*	Copyright (c) 1984, 1986, 1987, 1988, 1989 AT&T	*/
@@ -292,7 +294,7 @@
 	(bp)->av_forw = (bp)->av_back = NULL; \
 }
 
-#if defined(_KERNEL)
+#if defined(_KERNEL) || defined(_FAKE_KERNEL)
 /*
  * Macros to avoid the extra function call needed for binary compat.
  *
@@ -397,7 +399,7 @@
 struct buf *bioclone(struct buf *, off_t, size_t, dev_t, daddr_t,
 	int (*)(struct buf *), struct buf *, int);
 size_t	biosize(void);
-#endif	/* defined(_KERNEL) */
+#endif	/* defined(_KERNEL) || defined(_FAKE_KERNEL) */
 
 #ifdef	__cplusplus
 }
--- old/usr/src/uts/common/sys/cpupart.h	Mon Nov  6 02:54:43 2017
+++ new/usr/src/uts/common/sys/cpupart.h	Mon Nov  6 02:54:43 2017
@@ -20,6 +20,7 @@
  */
 /*
  * Copyright (c) 1996, 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright 2017 RackTop Systems.
  */
 
 #ifndef	_SYS_CPUPART_H
@@ -40,7 +41,7 @@
 extern "C" {
 #endif
 
-#ifdef _KERNEL
+#if defined(_KERNEL) || defined(_FAKE_KERNEL)
 
 typedef int	cpupartid_t;
 
@@ -148,7 +149,7 @@
 extern int	cpupart_setattr(psetid_t, uint_t);
 extern int	cpupart_getattr(psetid_t, uint_t *);
 
-#endif	/* _KERNEL */
+#endif	/* _KERNEL || _FAKE_KERNEL */
 
 #ifdef	__cplusplus
 }
--- old/usr/src/uts/common/sys/cpuvar.h	Mon Nov  6 02:54:43 2017
+++ new/usr/src/uts/common/sys/cpuvar.h	Mon Nov  6 02:54:43 2017
@@ -23,6 +23,7 @@
  * Copyright (c) 1989, 2010, Oracle and/or its affiliates. All rights reserved.
  * Copyright (c) 2012 by Delphix. All rights reserved.
  * Copyright 2014 Igor Kozhukhov <ikozhukhov@gmail.com>.
+ * Copyright 2017 RackTop Systems.
  */
 
 #ifndef _SYS_CPUVAR_H
@@ -32,6 +33,7 @@
 #include <sys/sysinfo.h>	/* has cpu_stat_t definition */
 #include <sys/disp.h>
 #include <sys/processor.h>
+#include <sys/kcpc.h>		/* has kcpc_ctx_t definition */
 
 #include <sys/loadavg.h>
 #if (defined(_KERNEL) || defined(_KMEMUSER)) && defined(_MACHDEP)
@@ -614,9 +616,9 @@
 #endif /* _KERNEL || _KMEMUSER */
 
 /*
- * CPU support routines.
+ * CPU support routines (not for genassym.c)
  */
-#if	defined(_KERNEL) && defined(__STDC__)	/* not for genassym.c */
+#if	defined(_KERNEL) || defined(_FAKE_KERNEL) && defined(__STDC__)
 
 struct zone;
 
@@ -823,7 +825,7 @@
 extern void cpu_vm_data_init(struct cpu *);
 extern void cpu_vm_data_destroy(struct cpu *);
 
-#endif	/* _KERNEL */
+#endif	/* _KERNEL || _FAKE_KERNEL */
 
 #ifdef	__cplusplus
 }
--- old/usr/src/uts/common/sys/cyclic.h	Mon Nov  6 02:54:43 2017
+++ new/usr/src/uts/common/sys/cyclic.h	Mon Nov  6 02:54:43 2017
@@ -21,6 +21,8 @@
 /*
  * Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ *
+ * Copyright 2017 RackTop Systems.
  */
 
 #ifndef _SYS_CYCLIC_H
@@ -72,7 +74,7 @@
 
 #define	CY_INFINITY	INT64_MAX
 
-#ifdef _KERNEL
+#if defined(_KERNEL) || defined(_FAKE_KERNEL)
 
 extern cyclic_id_t cyclic_add(cyc_handler_t *, cyc_time_t *);
 extern cyclic_id_t cyclic_add_omni(cyc_omni_handler_t *);
@@ -92,7 +94,7 @@
 extern void cyclic_fire(cpu_t *cpu);
 extern void cyclic_softint(cpu_t *cpu, cyc_level_t level);
 
-#endif /* _KERNEL */
+#endif /* _KERNEL || _FAKE_KERNEL */
 
 #endif /* !_ASM */
 
--- old/usr/src/uts/common/sys/fm/util.h	Mon Nov  6 02:54:43 2017
+++ new/usr/src/uts/common/sys/fm/util.h	Mon Nov  6 02:54:43 2017
@@ -21,6 +21,7 @@
 
 /*
  * Copyright (c) 2004, 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright 2017 RackTop Systems.
  */
 
 #ifndef	_SYS_FM_UTIL_H
@@ -70,7 +71,7 @@
 	} ed_tod_base;
 } erpt_dump_t;
 
-#ifdef _KERNEL
+#if defined(_KERNEL) || defined(_FAKE_KERNEL)
 #include <sys/systm.h>
 
 #define	FM_STK_DEPTH	20	/* maximum stack depth */
@@ -94,7 +95,7 @@
 extern void fm_payload_stack_add(nvlist_t *, const pc_t *, int);
 
 extern int is_fm_panic();
-#endif  /* _KERNEL */
+#endif  /* _KERNEL || _FAKE_KERNEL */
 
 #ifdef	__cplusplus
 }
--- old/usr/src/uts/common/sys/kobj.h	Mon Nov  6 02:54:43 2017
+++ new/usr/src/uts/common/sys/kobj.h	Mon Nov  6 02:54:43 2017
@@ -21,13 +21,13 @@
 /*
  * Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ *
+ * Copyright 2017 RackTop Systems.
  */
 
 #ifndef _SYS_KOBJ_H
 #define	_SYS_KOBJ_H
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sys/modctl.h>
 #include <sys/elf.h>
 #include <sys/machelf.h>
@@ -158,7 +158,7 @@
 
 #define	F_BLKS(file, size)	((size / (file)->_bsize) * (file)->_bsize)
 
-#if defined(_KERNEL)
+#if defined(_KERNEL) || defined(_FAKE_KERNEL)
 
 extern int kobj_load_module(struct modctl *, int);
 extern void kobj_unload_module(struct modctl *);
@@ -202,7 +202,7 @@
 extern void kobj_textwin_alloc(struct module *);
 extern void kobj_textwin_free(struct module *);
 
-#endif	/* defined(_KERNEL) */
+#endif	/* defined(_KERNEL) || defined(_FAKE_KERNEL) */
 
 #ifdef	__cplusplus
 }
--- old/usr/src/uts/common/sys/lgrp.h	Mon Nov  6 02:54:43 2017
+++ new/usr/src/uts/common/sys/lgrp.h	Mon Nov  6 02:54:43 2017
@@ -22,6 +22,8 @@
 /*
  * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ *
+ * Copyright 2017 RackTop Systems.
  */
 
 #ifndef	_LGRP_H
@@ -39,11 +41,11 @@
 
 #define	LGRP_NONE	(-1)		/* non-existent lgroup ID */
 
-#if (!defined(_KERNEL) && !defined(_KMEMUSER))
+#if !defined(_KERNEL) && !defined(_FAKE_KERNEL) && !defined(_KMEMUSER)
 typedef struct lgrp_mem_policy_info { int opaque[2]; }	lgrp_mem_policy_info_t;
-#endif	/* !_KERNEL && !_KMEMUSER */
+#endif	/* !_KERNEL && !_FAKE_KERNEL && !_KMEMUSER */
 
-#if (defined(_KERNEL) || defined(_KMEMUSER))
+#if defined(_KERNEL) || defined(_FAKE_KERNEL) || defined(_KMEMUSER)
 #include <sys/cpuvar.h>
 #include <sys/bitmap.h>
 #include <sys/vnode.h>
@@ -631,7 +633,7 @@
 extern uint32_t		lgrp_load_thresh;
 extern lgrp_mem_policy_t lgrp_mem_policy_root;
 
-#endif	/* _KERNEL && _KMEMUSER */
+#endif	/* _KERNEL || _FAKE_KERNEL || _KMEMUSER */
 
 #ifdef	__cplusplus
 }
--- old/usr/src/uts/common/sys/lgrp_user.h	Mon Nov  6 02:54:44 2017
+++ new/usr/src/uts/common/sys/lgrp_user.h	Mon Nov  6 02:54:44 2017
@@ -21,6 +21,7 @@
  */
 /*
  * Copyright 2014 Garrett D'Amore <garrett@damore.org>
+ * Copyright 2017 RackTop Systems.
  *
  * Copyright 2004 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
@@ -242,7 +243,7 @@
 #endif	/* _SYSCALL32 */
 
 
-#if (!defined(_KERNEL) && !defined(_KMEMUSER))
+#if !defined(_KERNEL) && !defined(_FAKE_KERNEL) && !defined(_KMEMUSER)
 
 lgrp_affinity_t	lgrp_affinity_get(idtype_t idtype, id_t id, lgrp_id_t lgrp);
 
@@ -285,7 +286,7 @@
 
 lgrp_view_t	lgrp_view(lgrp_cookie_t cookie);
 
-#endif	/* !_KERNEL && !_KMEMUSER */
+#endif	/* !_KERNEL && !_FAKE_KERNEL && !_KMEMUSER */
 
 #ifdef	__cplusplus
 }
--- old/usr/src/uts/common/sys/systeminfo.h	Mon Nov  6 02:54:44 2017
+++ new/usr/src/uts/common/sys/systeminfo.h	Mon Nov  6 02:54:44 2017
@@ -20,6 +20,7 @@
  */
 /*
  * Copyright 2014 Garrett D'Amore <garrett@damore.org>
+ * Copyright 2017 RackTop Systems.
  *
  * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
@@ -36,7 +37,7 @@
 extern "C" {
 #endif
 
-#ifdef	_KERNEL
+#if defined(_KERNEL) || defined(_FAKE_KERNEL)
 extern char architecture[];
 extern char architecture_32[];
 extern char hw_serial[];	/* machine's 32-bit hostid; a decimal string */
@@ -43,7 +44,7 @@
 extern char hw_provider[];
 extern char srpc_domain[];
 extern char platform[];
-#endif	/* _KERNEL */
+#endif	/* _KERNEL || _FAKE_KERNEL */
 
 /*
  * Commands to sysinfo(2)
--- old/usr/src/uts/common/sys/taskq.h	Mon Nov  6 02:54:44 2017
+++ new/usr/src/uts/common/sys/taskq.h	Mon Nov  6 02:54:44 2017
@@ -23,6 +23,7 @@
  * Use is subject to license terms.
  *
  * Copyright 2013 Nexenta Systems, Inc.  All rights reserved.
+ * Copyright 2017 RackTop Systems.
  */
 
 #ifndef	_SYS_TASKQ_H
@@ -62,7 +63,7 @@
 #define	TQ_NOALLOC	0x04	/* cannot allocate memory; may fail */
 #define	TQ_FRONT	0x08	/* Put task at the front of the queue */
 
-#if defined(_KERNEL) || defined(_FAKE_KERNEL)
+#if defined(_KERNEL) || defined(_FAKE_KERNEL) || defined(_TASKQUSER)
 
 extern taskq_t *system_taskq;
 
@@ -85,7 +86,7 @@
 extern void	taskq_resume(taskq_t *);
 extern int	taskq_member(taskq_t *, kthread_t *);
 
-#endif	/* _KERNEL */
+#endif	/* _KERNEL || _FAKE_KERNEL || _TASKQUSER */
 
 #ifdef	__cplusplus
 }
--- old/usr/src/uts/common/sys/taskq_impl.h	Mon Nov  6 02:54:44 2017
+++ new/usr/src/uts/common/sys/taskq_impl.h	Mon Nov  6 02:54:44 2017
@@ -25,6 +25,7 @@
 /*
  * Copyright 2011 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2017 by Delphix. All rights reserved.
+ * Copyright 2017 RackTop Systems.
  */
 
 #ifndef	_SYS_TASKQ_IMPL_H
@@ -35,6 +36,7 @@
 #include <sys/vmem.h>
 #include <sys/list.h>
 #include <sys/kstat.h>
+#include <sys/rwlock.h>
 
 #ifdef	__cplusplus
 extern "C" {
--- old/usr/src/uts/common/sys/vfs.h	Mon Nov  6 02:54:44 2017
+++ new/usr/src/uts/common/sys/vfs.h	Mon Nov  6 02:54:44 2017
@@ -22,7 +22,7 @@
 /*
  * Copyright (c) 1988, 2010, Oracle and/or its affiliates. All rights reserved.
  * Copyright 2016 Toomas Soome <tsoome@me.com>
- * Copyright (c) 2016 by Delphix. All rights reserved.
+ * Copyright (c) 2016, 2017 by Delphix. All rights reserved.
  * Copyright 2016 Nexenta Systems, Inc.
  */
 
@@ -416,6 +416,7 @@
 #define	VSW_XID		0x40	/* file system supports extended ids */
 #define	VSW_CANLOFI	0x80	/* file system supports lofi mounts */
 #define	VSW_ZMOUNT	0x100	/* file system always allowed in a zone */
+#define	VSW_MOUNTDEV	0x200	/* file system is mounted via device path */
 
 #define	VSW_INSTALLED	0x8000	/* this vsw is associated with a file system */
 
--- old/usr/src/uts/common/vm/seg_kmem.h	Mon Nov  6 02:54:44 2017
+++ new/usr/src/uts/common/vm/seg_kmem.h	Mon Nov  6 02:54:45 2017
@@ -22,6 +22,7 @@
  * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  * Copyright 2016 Joyent, Inc.
+ * Copyright 2017 RackTop Systems.
  */
 
 #ifndef _VM_SEG_KMEM_H
@@ -43,7 +44,7 @@
  * VM - Kernel Segment Driver
  */
 
-#if defined(_KERNEL)
+#if defined(_KERNEL) || defined(_FAKE_KERNEL)
 
 extern char *kernelheap;	/* start of primary kernel heap */
 extern char *ekernelheap;	/* end of primary kernel heap */
@@ -139,7 +140,7 @@
 
 extern struct seg_ops segkmem_ops;
 
-#endif	/* _KERNEL */
+#endif	/* _KERNEL || _FAKE_KERNEL */
 
 #ifdef	__cplusplus
 }
